import { MutatorFunc } from './mutation';
import { FactoryFunc } from './factory';
import { AggregateRoot, DomainEventEmitter, Entity, Repository } from './index';
export declare class AggregateRootImpl<T extends Entity, TEvents extends Record<string, any>> implements AggregateRoot<T, TEvents>, DomainEventEmitter<TEvents> {
    private __currentPromise;
    private __error;
    private __state;
    private __markedForDeletion;
    private readonly __events;
    private readonly __previousVersion;
    readonly state: Promise<T | null>;
    readonly error: Promise<Error | null>;
    readonly version: number;
    readonly events: Promise<{
        name: string;
        data: any;
    }[]>;
    constructor(state?: T | Error, version?: number);
    mutation<TCommand>(mutator: MutatorFunc<T, TCommand, TEvents>): (cmd: TCommand) => this;
    factory<TCommand, TCreated extends Entity>(factoryFunc: FactoryFunc<T, TCommand, TCreated, TEvents>): (cmd: TCommand) => Promise<AggregateRoot<TCreated, TEvents>>;
    'delete'(): this;
    commit<TActual extends Entity>(repo: T extends TActual ? Repository<T> : never): Promise<T>;
    readonly emit: any;
    emitFrom<T extends Record<string, any>>(): any;
}
