/**
 * Error which should be thrown by a repository when it cannot find an aggregate root
 */
export declare class AggregateNotFoundError extends Error {
    constructor(id: string);
}
/**
 * Error which should be thrown by a repository when an aggregate cannot be saved
 * because it had been saved already by another process
 */
export declare class ConcurrencyError extends Error {
    readonly reason: string;
    constructor(id: string, currentVersion: number, desiredVersion: number);
}
/**
 * A generic error which should be thrown by aggregate root when a command cannot be processed
 * either due to do it being incomplete or attempting to put the aggregate in an illegal state
 */
export declare class DomainError extends Error {
    readonly title: string;
    readonly reason: string;
    constructor(id: string, title: string, reason: string);
}
