import { DomainEvent } from './index';
export interface CoreEvents {
    AggregateDeleted: {
        types: string[];
    };
}
declare type Handler<T> = (ev: DomainEvent<T>) => void | Promise<any>;
declare type HandlerMap<T extends Record<string, any>> = {
    readonly [P in keyof T]: (handler: Handler<T[P]>) => (id: string, data: T[P]) => void | Promise<any>;
};
export declare function handler<T extends Record<string, any>>(): {
    on: HandlerMap<T>;
};
export declare function emit(name: string, ev: DomainEvent<any>): Promise<void>;
export declare function emitImmediate<T extends Record<string, any>, K extends keyof Pick<T, string>>(id: string, name: K, data: unknown extends T[K] ? never : T[K]): Promise<void>;
export {};
